Go to the latest version of this document.

# ``twisted`.`internet`.`defer``

module documentation
(source)

Support for results that aren't immediately available.

Maintainer: Glyph Lefkowitz

Class | `DebugInfo` | Deferred debug helper.
Class | `Deferred` | This is a callback which will be put off until later.
Class | `DeferredFilesystemLock` | A `FilesystemLock` that allows for a `Deferred` to be fired when the lock is acquired.
Class | `DeferredList` | `DeferredList` is a tool for collecting the results of several Deferreds.
Class | `DeferredLock` | A lock for event driven systems.
Class | `DeferredQueue` | An event driven queue.
Class | `DeferredSemaphore` | A semaphore for event driven systems.
Exception | `AlreadyCalledError` | This error is raised when one of `Deferred.callback` or `Deferred.errback` is called after one of the two had already been called.
Exception | `AlreadyTryingToLockError` | Raised when `DeferredFilesystemLock.deferUntilLocked` is called twice on a single `DeferredFilesystemLock`.
Exception | `CancelledError` | This error is raised by default when a `Deferred` is cancelled.
Exception | `FailureGroup` | More than one failure occurred.
Exception | `FirstError` | First error to occur in a `DeferredList` if `fireOnOneErrback` is set.
Exception | `NotACoroutineError` | This error is raised when a coroutine is expected and something else is encountered.
Exception | `QueueOverflow` | Undocumented
Exception | `QueueUnderflow` | Undocumented
Exception | `TimeoutError` | This error is raised by default when a `Deferred` times out.
Function | `ensureDeferred` | Schedule the execution of a coroutine that awaits/yields from `Deferred`s, wrapping it in a `Deferred` that will fire on success/failure of the coroutine. If a Deferred is passed to this function, it will be returned directly (mimicking the ...
Function | `execute` | Create a `Deferred` from a callable and arguments.
Function | `fail` | Return a `Deferred` that has already had `.errback(result)` called.
Function | `gatherResults` | Returns, via a `Deferred`, a list with the results of the given `Deferred`s - in effect, a "join" of multiple deferred operations.
Function | `getDebugging` | Determine whether `Deferred` debugging is enabled.
Function | `inlineCallbacks` | `inlineCallbacks` helps you write `Deferred`-using code that looks like a regular sequential function. For example:
Function | `logError` | Log and return failure.
Function | `maybeDeferred` | Invoke a function that may or may not return a `Deferred` or coroutine.
Function | `passthru` | Undocumented
Function | `race` | Select the first available result from the sequence of Deferreds and cancel the rest.
Function | `returnValue` | Return val from a `inlineCallbacks` generator.
Function | `setDebugging` | Enable or disable `Deferred` debugging.
Function | `succeed` | Return a `Deferred` that has already had `.callback(result)` called.
Function | `timeout` | Undocumented
Constant | `FAILURE` | Undocumented
Constant | `SUCCESS` | Undocumented
Type Alias | `DeferredCallback` | Undocumented
Type Alias | `DeferredErrback` | Undocumented
Variable | `log` | Undocumented
Class | `_CancellationStatus` | Cancellation status of an `inlineCallbacks` invocation.
Class | `_ConcurrencyPrimitive` | No class docstring; 0/1 instance variable, 2/7 methods documented
Class | `_Sentinel` | No summary
Exception | `_DefGen_Return` | Undocumented
Exception | `_InternalInlineCallbacksCancelledError` | A unique exception used only in `_cancellableInlineCallbacks` to verify that an `inlineCallbacks` is being cancelled as expected.
Function | `_addCancelCallbackToDeferred` | Helper for `_cancellableInlineCallbacks` to add `_handleCancelInlineCallbacks` as the first errback.
Function | `_cancellableInlineCallbacks` | Make an `@``inlineCallbacks` cancellable.
Function | `_cancelledToTimedOutError` | A default translation function that translates `Failure`s that are `CancelledError`s to `TimeoutError`s.
Function | `_DeferredList` | Undocumented
Function | `_failthru` | Undocumented
Function | `_gotResultInlineCallbacks` | Helper for `_inlineCallbacks` to handle a nested `Deferred` firing.
Function | `_handleCancelInlineCallbacks` | Propagate the cancellation of an `@``inlineCallbacks` to the `Deferred` it is waiting on.
Function | `_inlineCallbacks` | Carry out the work of `inlineCallbacks`.
Function | `_parseDeferredListResult` | Undocumented
Constant | `_DEFERRED_SUBCLASSES` | Undocumented
Constant | `_NONE_KWARGS` | Undocumented
Constant | `_P` | Undocumented
Type Variable | `_NextResultT` | Undocumented
Type Variable | `_SelfResultT` | Undocumented
Type Variable | `_T` | Undocumented
Type Alias | `_CallbackChain` | Undocumented
Type Alias | `_CallbackKeywordArguments` | Undocumented
Type Alias | `_CallbackOrderedArguments` | Undocumented
Type Alias | `_DeferredListResultItemT` | Undocumented
Type Alias | `_DeferredListResultListT` | Undocumented
Type Alias | `_DeferredListSingleResultT` | Undocumented
Variable | `_oldPypyStack` | Undocumented

def ensureDeferred(coro: `Coroutine[Deferred[Any], Any, _T] | Generator[Deferred[Any], Any, _T] | Deferred[_T]`) -> `Deferred[_T]`: (source)

Schedule the execution of a coroutine that awaits/yields from `Deferred`s, wrapping it in a `Deferred` that will fire on success/failure of the coroutine. If a Deferred is passed to this function, it will be returned directly (mimicking the `asyncio.ensure_future` function).

See `Deferred.fromCoroutine` for examples of coroutines.

Parameters
coro:`Coroutine[Deferred[Any], Any, _T] | Generator[Deferred[Any], Any, _T] | Deferred[_T]` | The coroutine object to schedule, or a `Deferred`.

Returns
`Deferred[_T]` | Undocumented

def execute(callable: `Callable[_P, _T]`, *args: `_P.args`, **kwargs: `_P.kwargs`) -> `Deferred[_T]`: (source)

Create a `Deferred` from a callable and arguments.

Call the given function with the given arguments. Return a `Deferred` which has been fired with its callback as the result of that invocation or its `errback` with a `Failure` for the exception thrown.

def fail(result: `Failure | BaseException | None` = None) -> `Deferred[Any]`: (source)

Return a `Deferred` that has already had `.errback(result)` called.

See `succeed`'s docstring for rationale.

Parameters
result:`Failure | BaseException | None` | The same argument that `Deferred.errback` takes.

Returns
`Deferred[Any]` | Undocumented

Raises
`NoCurrentExceptionError` | If `result` is `None` but there is no current exception state.

def gatherResults(deferredList: `Iterable[Deferred[_T]]`, consumeErrors: `bool` = False) -> `Deferred[list[_T]]`: (source)

Returns, via a `Deferred`, a list with the results of the given `Deferred`s - in effect, a "join" of multiple deferred operations.

The returned `Deferred` will fire when all of the provided `Deferred`s have fired, or when any one of them has failed.

This method can be cancelled by calling the `cancel` method of the `Deferred`, all the `Deferred`s in the list will be cancelled.

This differs from `DeferredList` in that you don't need to parse the result for success/failure.

Parameters
deferredList:`Iterable[Deferred[_T]]` | Undocumented

consumeErrors:`bool`

(keyword param) a flag, defaulting to False, indicating that failures in any of the given `Deferred`s should not be propagated to errbacks added to the individual `Deferred`s after this `gatherResults` invocation. Any such errors in the individual `Deferred`s will be converted to a callback result of `None`. This is useful to prevent spurious 'Unhandled error in Deferred' messages from being logged. This parameter is available since 11.1.0.

Returns
`Deferred[list[_T]]` | Undocumented

def getDebugging() -> `bool`: (source)

Determine whether `Deferred` debugging is enabled.

def inlineCallbacks(f: `Callable[_P, Generator[Deferred[Any], Any, _T]]`) -> `Callable[_P, Deferred[_T]]`: (source)

`inlineCallbacks` helps you write `Deferred`-using code that looks like a regular sequential function. For example:

        @inlineCallbacks
        def thingummy():
            thing = yield makeSomeRequestResultingInDeferred()
            print(thing)  # the result! hoorj!

When you call anything that results in a `Deferred`, you can simply yield it; your generator will automatically be resumed when the Deferred's result is available. The generator will be sent the result of the `Deferred` with the 'send' method on generators, or if the result was a failure, 'throw'.

Things that are not `Deferred`s may also be yielded, and your generator will be resumed with the same object sent back. This means `yield` performs an operation roughly equivalent to `maybeDeferred`.

Your inlineCallbacks-enabled generator will return a `Deferred` object, which will result in the return value of the generator (or will fail with a failure object if your generator raises an unhandled exception). Inside the generator simply use `return result` to return a value.

Be aware that generator must not return a `Deferred`. If you believe the thing you'd like to return could be a `Deferred`, do this:

        result = yield result
        return result

The `Deferred` returned from your deferred generator may errback if your generator raised an exception:

        @inlineCallbacks
        def thingummy():
            thing = yield makeSomeRequestResultingInDeferred()
            if thing == 'I love Twisted':
                # will become the result of the Deferred
                return 'TWISTED IS GREAT!'
            else:
                # will trigger an errback
                raise Exception('DESTROY ALL LIFE')

You can cancel the `Deferred` returned from your `inlineCallbacks` generator before it is fired by your generator completing (either by reaching its end, a `return` statement, or by calling `returnValue`). A `CancelledError` will be raised from the `yield`ed `Deferred` that has been cancelled if that `Deferred` does not otherwise suppress it.

`inlineCallbacks` behaves very similarly to coroutines. Since Twisted 24.7.0 it is possible to rewrite functions using `inlineCallbacks` to `async def` in piecewise manner and be mostly compatible to existing code.

The rewrite process is simply replacing `inlineCallbacks` decorator with `async def` and all `yield` occurrences in the function body with `await`. The function will no longer return a `Deferred` but a awaitable coroutine. This return value will obviously not have `Deferred` methods such as `addCallback`, but it will be possible to `yield` it in other code based on `inlineCallbacks`.

def logError(err: `Failure`) -> `Failure`: (source)

Log and return failure.

This method can be used as an errback that passes the failure on to the next errback unmodified. Note that if this is the last errback, and the deferred gets garbage collected after being this errback has been called, the clean up code logs it again.

@overload
def maybeDeferred(f: `Callable[_P, Deferred[_T]]`, *args: `_P.args`, **kwargs: `_P.kwargs`) -> `Deferred[_T]`:
@overload
def maybeDeferred(f: `Callable[_P, Coroutine[Deferred[Any], Any, _T]]`, *args: `_P.args`, **kwargs: `_P.kwargs`) -> `Deferred[_T]`:
@overload
def maybeDeferred(f: `Callable[_P, _T]`, *args: `_P.args`, **kwargs: `_P.kwargs`) -> `Deferred[_T]`:
(source)

Invoke a function that may or may not return a `Deferred` or coroutine.

Call the given function with the given arguments. Then:

- If the returned object is a `Deferred`, return it.
- If the returned object is a `Failure`, wrap it with `fail` and return it.
- If the returned object is a `types.CoroutineType`, wrap it with `Deferred.fromCoroutine` and return it.
- Otherwise, wrap it in `succeed` and return it.
- If an exception is raised, convert it to a `Failure`, wrap it in `fail`, and then return it.

Parameters
f:`Callable[_P, Deferred[_T] | Coroutine[Deferred[Any], Any, _T] | _T]` | The callable to invoke
*args:`_P.args` | The arguments to pass to `f`
**kwargs:`_P.kwargs` | The keyword arguments to pass to `f`

Returns
`Deferred[_T]` | The result of the function call, wrapped in a `Deferred` if necessary.

def passthru(arg: `_T`) -> `_T`: (source)

Undocumented

def race(ds: `Sequence[Deferred[_T]]`) -> `Deferred[tuple[int, _T]]`: (source)

Select the first available result from the sequence of Deferreds and cancel the rest.

Returns
`Deferred[tuple[int, _T]]` | A cancellable `Deferred` that fires with the index and output of the element of `ds` to have a success result first, or that fires with `FailureGroup` holding a list of their failures if they all fail.

def returnValue(val: `object`) -> `NoReturn`: (source)

Deprecated since version 24.7.0: `returnValue` was deprecated in Twisted 24.7.0; please use `standard return statement` instead.

Return val from a `inlineCallbacks` generator.

Note: this is currently implemented by raising an exception derived from `BaseException`. You might want to change any 'except:' clauses to an 'except Exception:' clause so as not to catch this exception.

Also: while this function currently will work when called from within arbitrary functions called from within the generator, do not rely upon this behavior.

def setDebugging(on: `bool`): (source)

Enable or disable `Deferred` debugging.

When debugging is on, the call stacks from creation and invocation are recorded, and added to any `AlreadyCalledError`s we raise.

def succeed(result: `_T`) -> `Deferred[_T]`: (source)

Return a `Deferred` that has already had `.callback(result)` called.

This is useful when you're writing synchronous code to an asynchronous interface: i.e., some code is calling you expecting a `Deferred` result, but you don't actually need to do anything asynchronous. Just return `defer.succeed(theResult)`.

See `fail` for a version of this function that uses a failing `Deferred` rather than a successful one.

Parameters
result:`_T` | The result to give to the Deferred's 'callback' method.

Returns
`Deferred[_T]` | Undocumented

def timeout(deferred: `Deferred[object]`): (source)

Deprecated since version 17.1.0: `timeout` was deprecated in Twisted 17.1.0; please use `twisted.internet.defer.Deferred.addTimeout` instead.

Undocumented

FAILURE: `bool` = (source)

Undocumented

Value

    False

SUCCESS: `bool` = (source)

Undocumented

Value

    True

DeferredCallback = (source)

Undocumented

Value

    Callable[..., object]

DeferredErrback = (source)

Undocumented

Value

    Callable[..., object]

log = (source)

Undocumented

def _addCancelCallbackToDeferred(it: `Deferred[_T]`, status: `_CancellationStatus[_T]`): (source)

Helper for `_cancellableInlineCallbacks` to add `_handleCancelInlineCallbacks` as the first errback.

Parameters
it:`Deferred[_T]` | The `Deferred` to add the errback to.
status:`_CancellationStatus[_T]` | a `_CancellationStatus` tracking the current status of `gen`

def _cancellableInlineCallbacks(gen: `Generator[Deferred[Any], object, _T] | Coroutine[Deferred[Any], object, _T]`) -> `Deferred[_T]`: (source)

Make an `@``inlineCallbacks` cancellable.

Parameters
gen:`Generator[Deferred[Any], object, _T] | Coroutine[Deferred[Any], object, _T]` | a generator object returned by calling a function or method decorated with `@``inlineCallbacks`

Returns
`Deferred[_T]` | `Deferred` for the `@``inlineCallbacks` that is cancellable.

def _cancelledToTimedOutError(value: `_T`, timeout: `float`) -> `_T`: (source)

A default translation function that translates `Failure`s that are `CancelledError`s to `TimeoutError`s.

Parameters
value:`_T` | Anything
timeout:`float` | The timeout

Returns
`_T` | Undocumented

Raises
`TimeoutError` | If `value` is a `Failure` that is a `CancelledError`.
`Exception` | If `value` is a `Failure` that is not a `CancelledError`, it is re-raised.

Present Since
16.5

@overload
def _DeferredList(deferredList: `Iterable[Deferred[_SelfResultT]]`, fireOnOneCallback: `Literal[True]`, fireOnOneErrback: `bool` = False, consumeErrors: `bool` = False) -> `Deferred[_DeferredListSingleResultT[_SelfResultT]]`:
@overload
def _DeferredList(deferredList: `Iterable[Deferred[_SelfResultT]]`, fireOnOneCallback: `Literal[False]` = False, fireOnOneErrback: `bool` = False, consumeErrors: `bool` = False) -> `Deferred[_DeferredListResultListT[_SelfResultT]]`:
(source)

Undocumented

def _failthru(arg: `Failure`) -> `Failure`: (source)

Undocumented

def _gotResultInlineCallbacks(r: `object`, waiting: `list[Any]`, gen: `Generator[Deferred[Any], Any, _T] | Coroutine[Deferred[Any], Any, _T]`, status: `_CancellationStatus[_T]`, context: `_Context`): (source)

Helper for `_inlineCallbacks` to handle a nested `Deferred` firing.

Parameters
r:`object` | The result of the `Deferred`
waiting:`list[Any]` | Whether the `_inlineCallbacks` was waiting, and the result.
gen:`Generator[Deferred[Any], Any, _T] | Coroutine[Deferred[Any], Any, _T]` | a generator object returned by calling a function or method decorated with `@``inlineCallbacks`
status:`_CancellationStatus[_T]` | a `_CancellationStatus` tracking the current status of `gen`
context:`_Context` | the contextvars context to run `gen` in

def _handleCancelInlineCallbacks(result: `Failure`, status: `_CancellationStatus[_T]`, /) -> `Deferred[_T]`: (source)

Propagate the cancellation of an `@``inlineCallbacks` to the `Deferred` it is waiting on.

Parameters
result:`Failure` | An `_InternalInlineCallbacksCancelledError` from `cancel()`.
status:`_CancellationStatus[_T]` | a `_CancellationStatus` tracking the current status of `gen`

Returns
`Deferred[_T]` | A new `Deferred` that the `@``inlineCallbacks` generator can callback or errback through.

@_extraneous
def _inlineCallbacks(result: `object`, gen: `Generator[Deferred[Any], Any, _T] | Coroutine[Deferred[Any], Any, _T]`, status: `_CancellationStatus[_T]`, context: `_Context`): (source)

Carry out the work of `inlineCallbacks`.

Iterate the generator produced by an `@``inlineCallbacks`-decorated function, `gen`, `send()`ing it the results of each value `yield`ed by that generator, until a `Deferred` is yielded, at which point a callback is added to that `Deferred` to call this function again.

Parameters
result:`object` | The last result seen by this generator. Note that this is never a `Deferred` - by the time this function is invoked, the `Deferred` has been called back and this will be a particular result at a point in its callback chain.
gen:`Generator[Deferred[Any], Any, _T] | Coroutine[Deferred[Any], Any, _T]` | a generator object returned by calling a function or method decorated with `@``inlineCallbacks`
status:`_CancellationStatus[_T]` | a `_CancellationStatus` tracking the current status of `gen`
context:`_Context` | the contextvars context to run `gen` in

def _parseDeferredListResult(resultList: `list[_DeferredListResultItemT[_T]]`, fireOnOneErrback: `bool` = False, /) -> `list[_T]`: (source)

Undocumented

_DEFERRED_SUBCLASSES = (source)

Undocumented

Value

    [Deferred]

_NONE_KWARGS: `_CallbackKeywordArguments` = (source)

Undocumented

Value

    MappingProxyType({})

_P = (source)

Undocumented

Value

    ParamSpec('_P')

_NextResultT = (source)

Undocumented

Value

    TypeVar('_NextResultT')

_SelfResultT = (source)

Undocumented

Value

    TypeVar('_SelfResultT')

_T = (source)

Undocumented

Value

    TypeVar('_T')

_CallbackChain = (source)

Undocumented

Value

    tuple[tuple[DeferredCallback | Literal[_Sentinel._CONTINUE],
                _CallbackOrderedArguments,
                _CallbackKeywordArguments],
          tuple[DeferredErrback | DeferredCallback | Literal[_Sentinel._CONTINUE],
                _CallbackOrderedArguments,
                _CallbackKeywordArguments]]

_CallbackKeywordArguments = (source)

Undocumented

Value

    Mapping[str, object]

_CallbackOrderedArguments = (source)

Undocumented

Value

    tuple[object, ...]

_DeferredListResultItemT = (source)

Undocumented

Value

    tuple[bool, _SelfResultT]

_DeferredListResultListT = (source)

Undocumented

Value

    list[_DeferredListResultItemT[_SelfResultT]]

_DeferredListSingleResultT = (source)

Undocumented

Value

    tuple[_SelfResultT, int]

_oldPypyStack = (source)

Undocumented